#include "..\C-Engine\CHeader.hpp"
#include"BoatControl.hpp"
#include "BoatControlPirate.hpp"

extern "C"
{
#include <math.h>
}


void BoatControlPirate::Start()
{
    StartBoat();

    GetObject()->AddRigibody();

    GetObject()->AffectTag("Pirate"); //On crit que c'est un pirate
    GetObject()->GetRigibody()->SetMass(500);

    BateauActuelle->VoilesLongitudinal.Pourcentage = 0;//On met ces voiles  0
    BateauActuelle->VoilesLateralle.Pourcentage = 0;

    BateauActuelle->viemax = 3;//Les pirates ont 3 de vies.
    BateauActuelle->vie = BateauActuelle->viemax ;

    BateauActuelle->CanonDroit.couldown = 0;
    BateauActuelle->CanonGauche.couldown = 0;
}


void BoatControlPirate::Update()
{
    UpdateBoat();

    int difx , dify ;
    int distance;
    float angle , difangle;

    difx = GetX() - GetEngine()->GetListeObject()[0]->GetTransforms()->GetX();
    dify = GetY() - GetEngine()->GetListeObject()[0]->GetTransforms()->GetY();

    distance = sqrt( difx * difx + dify * dify); //On calcul la distance entre le joueur et le bateau pirate.

    angle = 360 - 90 - radtodegre(atan2( difx , dify));

    if(angle > 360) angle -= 360;
    if(angle < 0) angle += 360;

    difangle = angle - direction;

    if(distance < 50 || distance > 350)
    {
        difangle = angle - direction + 90;

        BateauActuelle->VoilesLateralle.Pourcentage =  BateauActuelle->VoilesLateralle.Pourcentage - 3;
        BateauActuelle->VoilesLongitudinal.Pourcentage =  BateauActuelle->VoilesLongitudinal.Pourcentage - 3;
    }
    else
    {
        if(BateauActuelle->VoilesLateralle.Pourcentage < 70)BateauActuelle->VoilesLateralle.Pourcentage =  BateauActuelle->VoilesLateralle.Pourcentage + 2;
        if(BateauActuelle->VoilesLateralle.Pourcentage < 70)BateauActuelle->VoilesLongitudinal.Pourcentage =  BateauActuelle->VoilesLongitudinal.Pourcentage + 2;
    }

    if(difangle > 360) difangle -= 360;
    if(difangle < 0) difangle += 360;

    if(difangle  < 180 && difangle > 2)Turn(2);//On aligne le bateau dans la bonne direction
    if(difangle  > 180 && difangle < 358) Turn(-2);

    if(distance < 50)
    {
        Fire(90);
        Fire(-90);

    }

    int affichage = BateauActuelle->vie * 15 / BateauActuelle->viemax;//On affiche la vie du pirate  sa gauche.
    PrintMini( GetObject()->GetTransforms()->GetRelativeX() + 18 , 63 - GetObject()->GetTransforms()->GetRelativeY() - 10 , "P" , 0);
    ML_line( GetObject()->GetTransforms()->GetRelativeX() - 2 , 62 - GetObject()->GetTransforms()->GetRelativeY() , GetObject()->GetTransforms()->GetRelativeX() - 2 , 62 - GetObject()->GetTransforms()->GetRelativeY() - affichage, ML_BLACK);


    Object * Buffer = NULL;

    Buffer = GetObject()->CollisionTagO("Boulet");

    if(Buffer != NULL)//Si il est touch par un boulet de canon il perd une vie.
    {
        GetEngine()->DelObject(Buffer);

        BateauActuelle->vie --;
    }

    if( BateauActuelle->vie <= 0)//Si il n'a plus de vie il meurt.
    {
        GetEngine()->DelObject(GetObject());
    }


}


void BoatControlPirate::Fire( float angle)//Pareil que pour le BoatControl , seul le tag change.
{
    if(angle == 90)
    {
        if(BateauActuelle->CanonDroit.couldown <= 0)
            {
            float angletire;

            angletire = direction - angle;

            Object * Buffer = new Object;

            Buffer->GetTransforms()->SetXY( GetX() + 8 , GetY() + 8);
            Buffer->GetRender()->SetRender(RenderBoulet , 1);
            Buffer->AddRigibody();
            Buffer->GetRigibody()->SetMass(5);

            Buffer->AffectTag("BouletP");

            SBoulet * Script_Boulet = new SBoulet;
            Buffer->AffectScript(Script_Boulet);

            Script_Boulet->time = 20;

            Buffer->GetRigibody()->GetBody()->velocity.x = cos(degretorad(angletire)) * 40;
            Buffer->GetRigibody()->GetBody()->velocity.y = sin(degretorad(angletire)) * 40;

            GetEngine()->AddObject(Buffer);

            BateauActuelle->CanonDroit.couldown = 100;
            }
    }

    if(angle == -90)
    {
        if(BateauActuelle->CanonGauche.couldown <= 0)
            {
            float angletire;

            angletire = direction - angle;

            Object * Buffer = new Object;

            Buffer->GetTransforms()->SetXY( GetX() + 8 , GetY() + 8);
            Buffer->GetRender()->SetRender(RenderBoulet , 1);
            Buffer->AddRigibody();
            Buffer->GetRigibody()->SetMass(5);

            Buffer->AffectTag("BouletP");

            SBoulet * Script_Boulet = new SBoulet;
            Buffer->AffectScript(Script_Boulet);

            Script_Boulet->time = 20;

            Buffer->GetRigibody()->GetBody()->velocity.x = cos(degretorad(angletire)) * 40;
            Buffer->GetRigibody()->GetBody()->velocity.y = sin(degretorad(angletire)) * 40;
            Buffer->GetRigibody()->GetBody()->velocity.y = sin(degretorad(angletire)) * 40;

            GetEngine()->AddObject(Buffer);

            BateauActuelle->CanonGauche.couldown = 100;
            }
    }
}
